com.fasterxml.jackson.databind.ser.std

## Class BeanSerializerBase

- java.lang.Object
- - com.fasterxml.jackson.databind.JsonSerializer<T>
  - - com.fasterxml.jackson.databind.ser.std.StdSerializer<Object>
    - - com.fasterxml.jackson.databind.ser.std.BeanSerializerBase

All Implemented Interfaces:
  JsonFormatVisitable, SchemaAware, ContextualSerializer, ResolvableSerializer

Direct Known Subclasses:
  BeanAsArraySerializer, BeanSerializer, UnwrappingBeanSerializer

    public abstract class BeanSerializerBase
    extends StdSerializer<Object>
    implements ContextualSerializer, ResolvableSerializer, JsonFormatVisitable, SchemaAware

Base class both for the standard bean serializer, and couple of variants that only differ in small details. Can be used for custom bean serializers as well, although that is not the primary design goal.

### Nested Class Summary

### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonSerializer

`JsonSerializer.None`

### Field Summary

Fields
`protected AnyGetterWriter` `_anyGetterWriter` Handler for `JsonAnyGetter` annotated properties
`protected BeanPropertyWriter[]` `_filteredProps` Optional filters used to suppress output of properties that are only to be included in certain views
`protected ObjectIdWriter` `_objectIdWriter` If this POJO can be alternatively serialized using just an object id to denote a reference to previously serialized object, this Object will handle details.
`protected Object` `_propertyFilterId` Id of the bean property filter to use, if any; null if none.
`protected BeanPropertyWriter[]` `_props` Writers used for outputting actual property values
`protected JsonFormat.Shape` `_serializationShape` Requested shape from bean class annotations.
`protected AnnotatedMember` `_typeId` If using custom type ids (usually via getter, or field), this is the reference to that member.
`protected static BeanPropertyWriter[]` `NO_PROPS`

### Fields inherited from class com.fasterxml.jackson.databind.ser.std.StdSerializer

`_handledType`

### Constructor Summary

Constructors
`protected` `BeanSerializerBase(BeanSerializerBase src)` Copy-constructor that is useful for sub-classes that just want to copy all super-class properties without modifications.
`` `BeanSerializerBase(BeanSerializerBase src, BeanPropertyWriter[] properties, BeanPropertyWriter[] filteredProperties)`
`protected` `BeanSerializerBase(BeanSerializerBase src, NameTransformer unwrapper)` Copy-constructor that will also rename properties with given prefix (if it's non-empty)
`protected` `BeanSerializerBase(BeanSerializerBase src, ObjectIdWriter objectIdWriter)`
`protected` `BeanSerializerBase(BeanSerializerBase src, String[] toIgnore)`
`protected` `BeanSerializerBase(JavaType type, BeanSerializerBuilder builder, BeanPropertyWriter[] properties, BeanPropertyWriter[] filteredProperties)` Constructor used by `BeanSerializerBuilder` to create an instance

### Method Summary

Methods
`protected void` `_serializeWithObjectId(Object bean, JsonGenerator jgen, SerializerProvider provider, boolean startEndObject)`
`protected void` `_serializeWithObjectId(Object bean, JsonGenerator jgen, SerializerProvider provider, TypeSerializer typeSer)`
`void` `acceptJsonFormatVisitor(JsonFormatVisitorWrapper visitor, JavaType typeHint)` Default implementation specifies no format.
`protected abstract BeanSerializerBase` `asArraySerializer()` Fluent factory for creating a variant that output POJO as a JSON Array.
`JsonSerializer<?>` `createContextual(SerializerProvider provider, BeanProperty property)` Method called to see if a different (or differently configured) serializer is needed to serialize values of specified property.
`protected JsonSerializer<Object>` `findConvertingSerializer(SerializerProvider provider, BeanPropertyWriter prop)` Helper method that can be used to see if specified property is annotated to indicate use of a converter for property value (in case of container types, it is container type itself, not key or content type).
`protected BeanPropertyFilter` `findFilter(SerializerProvider provider)` Helper method used to locate filter that is needed, based on filter id this serializer was constructed with.
`JsonNode` `getSchema(SerializerProvider provider, Type typeHint)` Default implementation simply claims type is "string"; usually overriden by custom serializers.
`void` `resolve(SerializerProvider provider)` We need to implement `ResolvableSerializer` to be able to properly handle cyclic type references.
`abstract void` `serialize(Object bean, JsonGenerator jgen, SerializerProvider provider)` Method that can be called to ask implementation to serialize values of type this serializer handles.
`protected void` `serializeFields(Object bean, JsonGenerator jgen, SerializerProvider provider)`
`protected void` `serializeFieldsFiltered(Object bean, JsonGenerator jgen, SerializerProvider provider)` Alternative serialization method that gets called when there is a `BeanPropertyFilter` that needs to be called to determine which properties are to be serialized (and possibly how)
`void` `serializeWithType(Object bean, JsonGenerator jgen, SerializerProvider provider, TypeSerializer typeSer)` Method that can be called to ask implementation to serialize values of type this serializer handles, using specified type serializer for embedding necessary type information.
`boolean` `usesObjectId()` Method that can be called to see whether this serializer instance will use Object Id to handle cyclic references.
`protected abstract BeanSerializerBase` `withIgnorals(String[] toIgnore)` Fluent factory used for creating a new instance with additional set of properties to ignore (from properties this instance otherwise has)
`abstract BeanSerializerBase` `withObjectIdWriter(ObjectIdWriter objectIdWriter)` Fluent factory used for creating a new instance with different `ObjectIdWriter`.

### Methods inherited from class com.fasterxml.jackson.databind.ser.std.StdSerializer

`createObjectNode, createSchemaNode, createSchemaNode, findConvertingContentSerializer, getSchema, handledType, isDefaultSerializer, wrapAndThrow, wrapAndThrow`

### Methods inherited from class com.fasterxml.jackson.databind.JsonSerializer

`getDelegatee, isEmpty, isUnwrappingSerializer, replaceDelegatee, unwrappingSerializer`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface com.fasterxml.jackson.databind.jsonschema.SchemaAware

`getSchema`

### Field Detail

#### NO_PROPS

    protected static final BeanPropertyWriter[] NO_PROPS

#### _props

    protected final BeanPropertyWriter[] _props

Writers used for outputting actual property values

#### _filteredProps

    protected final BeanPropertyWriter[] _filteredProps

Optional filters used to suppress output of properties that are only to be included in certain views

#### _anyGetterWriter

    protected final AnyGetterWriter _anyGetterWriter

Handler for `JsonAnyGetter` annotated properties

#### _propertyFilterId

    protected final Object _propertyFilterId

Id of the bean property filter to use, if any; null if none.

#### _typeId

    protected final AnnotatedMember _typeId

If using custom type ids (usually via getter, or field), this is the reference to that member.

#### _objectIdWriter

    protected final ObjectIdWriter _objectIdWriter

If this POJO can be alternatively serialized using just an object id to denote a reference to previously serialized object, this Object will handle details.

#### _serializationShape

    protected final JsonFormat.Shape _serializationShape

Requested shape from bean class annotations.

### Constructor Detail

#### BeanSerializerBase

    protected BeanSerializerBase(JavaType type,
                      BeanSerializerBuilder builder,
                      BeanPropertyWriter[] properties,
                      BeanPropertyWriter[] filteredProperties)

Constructor used by `BeanSerializerBuilder` to create an instance

Parameters:
  `type` - Nominal type of values handled by this serializer
  `builder` - Builder for accessing other collected information

#### BeanSerializerBase

    public BeanSerializerBase(BeanSerializerBase src,
                      BeanPropertyWriter[] properties,
                      BeanPropertyWriter[] filteredProperties)

#### BeanSerializerBase

    protected BeanSerializerBase(BeanSerializerBase src,
                      ObjectIdWriter objectIdWriter)

#### BeanSerializerBase

    protected BeanSerializerBase(BeanSerializerBase src,
                      String[] toIgnore)

#### BeanSerializerBase

    protected BeanSerializerBase(BeanSerializerBase src)

Copy-constructor that is useful for sub-classes that just want to copy all super-class properties without modifications.

#### BeanSerializerBase

    protected BeanSerializerBase(BeanSerializerBase src,
                      NameTransformer unwrapper)

Copy-constructor that will also rename properties with given prefix (if it's non-empty)

### Method Detail

#### withObjectIdWriter

    public abstract BeanSerializerBase withObjectIdWriter(ObjectIdWriter objectIdWriter)

Fluent factory used for creating a new instance with different `ObjectIdWriter`.

Since:
  2.0

#### withIgnorals

    protected abstract BeanSerializerBase withIgnorals(String[] toIgnore)

Fluent factory used for creating a new instance with additional set of properties to ignore (from properties this instance otherwise has)

Since:
  2.0

#### asArraySerializer

    protected abstract BeanSerializerBase asArraySerializer()

Fluent factory for creating a variant that output POJO as a JSON Array. Implementations may ignore this request if output as array is not possible (either at all, or reliably).

Since:
  2.1

#### resolve

    public void resolve(SerializerProvider provider)
                 throws JsonMappingException

We need to implement `ResolvableSerializer` to be able to properly handle cyclic type references.

Specified by:
  `resolve` in interface `ResolvableSerializer`
Parameters:
  `provider` - Provider that has constructed serializer this method is called on.
Throws:
  `JsonMappingException`

#### findConvertingSerializer

    protected JsonSerializer<Object> findConvertingSerializer(SerializerProvider provider,
                                                  BeanPropertyWriter prop)
                                                       throws JsonMappingException

Helper method that can be used to see if specified property is annotated to indicate use of a converter for property value (in case of container types, it is container type itself, not key or content type).

Throws:
  `JsonMappingException`
Since:
  2.2

#### createContextual

    public JsonSerializer<?> createContextual(SerializerProvider provider,
                                     BeanProperty property)
                                       throws JsonMappingException

Description copied from interface: `ContextualSerializer`
Method called to see if a different (or differently configured) serializer is needed to serialize values of specified property. Note that instance that this method is called on is typically shared one and as a result method should NOT modify this instance but rather construct and return a new instance. This instance should only be returned as-is, in case it is already suitable for use.

Specified by:
  `createContextual` in interface `ContextualSerializer`
Parameters:
  `provider` - Serializer provider to use for accessing config, other serializers
  `property` - Method or field that represents the property (and is used to access value to serialize). Should be available; but there may be cases where caller can not provide it and null is passed instead (in which case impls usually pass 'this' serializer as is)
Returns:
  Serializer to use for serializing values of specified property; may be this instance or a new instance.
Throws:
  `JsonMappingException`

#### usesObjectId

    public boolean usesObjectId()

Description copied from class: `JsonSerializer`
Method that can be called to see whether this serializer instance will use Object Id to handle cyclic references.

Overrides:
  `usesObjectId` in class `JsonSerializer<Object>`

#### serialize

    public abstract void serialize(Object bean,
                 JsonGenerator jgen,
                 SerializerProvider provider)
                            throws IOException,
                                   JsonGenerationException

Description copied from class: `JsonSerializer`
Method that can be called to ask implementation to serialize values of type this serializer handles.

Specified by:
  `serialize` in class `StdSerializer<Object>`
Parameters:
  `bean` - Value to serialize; can not be null.
  `jgen` - Generator used to output resulting Json content
  `provider` - Provider that can be used to get serializers for serializing Objects value contains, if any.
Throws:
  `IOException`
  `JsonGenerationException`

#### serializeWithType

    public void serializeWithType(Object bean,
                         JsonGenerator jgen,
                         SerializerProvider provider,
                         TypeSerializer typeSer)
                           throws IOException,
                                  JsonGenerationException

Description copied from class: `JsonSerializer`
Method that can be called to ask implementation to serialize values of type this serializer handles, using specified type serializer for embedding necessary type information.

Default implementation will throw `UnsupportedOperationException` to indicate that proper type handling needs to be implemented.

For simple datatypes written as a single scalar value (JSON String, Number, Boolean), implementation would look like:

      // note: method to call depends on whether this type is serialized as JSON scalar, object or Array!
      typeSer.writeTypePrefixForScalar(value, jgen);
      serialize(value, jgen, provider);
      typeSer.writeTypeSuffixForScalar(value, jgen);

and implementations for type serialized as JSON Arrays or Objects would differ slightly, as `START-ARRAY>/`END-ARRAY` and `START-OBJECT>/`END-OBJECT` pairs need to be properly handled with respect to serializing of contents.``

Overrides:
  `serializeWithType` in class `JsonSerializer<Object>`
Parameters:
  `bean` - Value to serialize; can not be null.
  `jgen` - Generator used to output resulting Json content
  `provider` - Provider that can be used to get serializers for serializing Objects value contains, if any.
  `typeSer` - Type serializer to use for including type information
Throws:
  `IOException`
  `JsonGenerationException`

#### _serializeWithObjectId

    protected final void _serializeWithObjectId(Object bean,
                              JsonGenerator jgen,
                              SerializerProvider provider,
                              boolean startEndObject)
                                         throws IOException,
                                                JsonGenerationException

Throws:
  `IOException`
  `JsonGenerationException`

#### _serializeWithObjectId

    protected final void _serializeWithObjectId(Object bean,
                              JsonGenerator jgen,
                              SerializerProvider provider,
                              TypeSerializer typeSer)
                                         throws IOException,
                                                JsonGenerationException

Throws:
  `IOException`
  `JsonGenerationException`

#### serializeFields

    protected void serializeFields(Object bean,
                       JsonGenerator jgen,
                       SerializerProvider provider)
                            throws IOException,
                                   JsonGenerationException

Throws:
  `IOException`
  `JsonGenerationException`

#### serializeFieldsFiltered

    protected void serializeFieldsFiltered(Object bean,
                               JsonGenerator jgen,
                               SerializerProvider provider)
                                    throws IOException,
                                           JsonGenerationException

Alternative serialization method that gets called when there is a `BeanPropertyFilter` that needs to be called to determine which properties are to be serialized (and possibly how)

Throws:
  `IOException`
  `JsonGenerationException`

#### findFilter

    protected BeanPropertyFilter findFilter(SerializerProvider provider)
                                     throws JsonMappingException

Helper method used to locate filter that is needed, based on filter id this serializer was constructed with.

Throws:
  `JsonMappingException`

#### getSchema

    public JsonNode getSchema(SerializerProvider provider,
                     Type typeHint)
                       throws JsonMappingException

Description copied from class: `StdSerializer`
Default implementation simply claims type is "string"; usually overriden by custom serializers.

Specified by:
  `getSchema` in interface `SchemaAware`
Overrides:
  `getSchema` in class `StdSerializer<Object>`
Parameters:
  `provider` - The serializer provider.
  `typeHint` - A hint about the type.
Returns:
  Json-schema for this serializer.
Throws:
  `JsonMappingException`

#### acceptJsonFormatVisitor

    public void acceptJsonFormatVisitor(JsonFormatVisitorWrapper visitor,
                               JavaType typeHint)
                                 throws JsonMappingException

Description copied from class: `StdSerializer`
Default implementation specifies no format. This behavior is usually overriden by custom serializers.

Specified by:
  `acceptJsonFormatVisitor` in interface `JsonFormatVisitable`
Overrides:
  `acceptJsonFormatVisitor` in class `StdSerializer<Object>`
  `typeHint` - Type of element (entity like property) being visited
Throws:
  `JsonMappingException`